#include <Password.h>

#include <Keypad.h>

#define MOSI 4
#define MISO 5
#define SCK  6
#define CS   1
bool csLow = false;

//Définition du clavier 3 x3 boutons
const byte ROWS = 3; //3 lignes
const byte COLS = 3; //3 colonnes
// Donner un code Ascii aux 16 touches, par exemple 0-F
char keys[ROWS][COLS] = {
  {'3','6','9'},
  {'2','5','8'},
  {'1','4','7'}
};

int i = 0;
byte rowPins[ROWS] = {7, 6, 5}; //les 3 lignes du clavier sur les pins arduino digitales
byte colPins[COLS] = {10, 9, 8}; //les 3 colonnes du clavier

//Créer cet objet clavier
Keypad keypad = Keypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS );


//Création du mot de passe
Password password = Password( "1234" );

void setup(){
//  Serial.begin(9600);   //Moniteur série (écran PC)
//  Serial.println("Utilisation du clavier 3 x 3 touches");
  pinMode(0,OUTPUT);
  setupSPI();
}

int valide=0;

void setupSPI(void){
  //pin setup
  pinMode(MOSI,   INPUT);
  pinMode(MISO,  OUTPUT);
  pinMode(SCK,    INPUT);
  pinMode(CS,     INPUT);
  //chip select interrupt
  attachInterrupt(CS,chipSelect,FALLING);
  //actual USI setup
  USICR = 0; //set everything to zero.
  USICR = (1 << USIWM0) | (1 << USICS1) | (1 << USIOIE); //Three wire mode0, External clock positive edge both edges, Enable interrupt
}


void loop(){
  
  char key = keypad.getKey();   //Surveiller le clavier

  while ( not password.evaluate()) {
    char key = keypad.getKey();
    if (key != NO_KEY) {
      password.append(key);
      i ++; 
      }
    if (not password.evaluate() and i == 4 )
      {
      password.reset();
      i = 0;
      digitalWrite(0,HIGH);
      delay(100);
      digitalWrite(0,LOW);
      }
    }
  valide=1;
  digitalWrite(0,HIGH);
  delay(500);
  digitalWrite(0,LOW);
  delay(500);
}

void chipSelect(){//this tells the Tiny that the data coming in is for it.
  csLow = true; //resetting is the job of the SPI overflow handler  
}

//then send the message which should trigger the ISR
ISR(USI_OVF_vect)
{//overflow
  byte c = USIDR; //read the USI Data Buffer
  USISR = 1 << USIOIF; //clear the interrupt flag, yeah I know, it needs to be set to 1 to clear and reset the counter
  if(csLow){
    USIDR = valide;
  }
  else{
    pinMode(MISO,INPUT); //reverse it so it doesn't interfere with other slaves
  }
  csLow = false;
  }
